' SCE (Chip Select) Pin 2
' RST (Reset) Pin 4
' D/C (data command) Pin 5
' (mosi) SPI Out pin 3
' SCLK (SPI Clock) Pin 25

SetPin 2, 8 'Digital Output for SPI Chip Select
SetPin 4, 8 'Digital Output for LCD RST
SetPin 5, 8 'Digital Output for LCD D/C

I2CADDR=&H50 ' 24C32
GoSub Codes

GoSub ReadTime

Pin(2) = 1 ' Enable High
Pause 25

Pin(2) = 0 ' Enable is active low
SPI Open 1000000, 3, 8 'Setup SPI

DC = 5
RST = 4

Dim Column(16)
Dim LCDstr(26)

GoSub LCD_INIT
GoSub LCD_Clear

SetTick 1000, ReadTemp, 1 'Read Temperature once at 1 second

  PosX=60 : Posy=3 : GoSub LCD_GotoXY
  Text$=";" : Font = 1           ' Degree Symbol
    Lookup
  GoSub LCD_StringOut


Start:

T$=Time$
D$=Date$


  PosX=0 : PosY=0 : GoSub LCD_GotoXY
  Text$ = "   "+T$ : Font=0
    Lookup
  GoSub LCD_StringOut

  PosX=0 : PosY=1 : GoSub LCD_GotoXY
  Text$ = "  "+D$ : Font=0
    Lookup
  GoSub LCD_StringOut

  PosX=12 : PosY=3 : GoSub LCD_GotoXY
  Text$ = Temp$ : Font=1
    Lookup
  GoSub LCD_StringOut

GoTo start

LoopA:
  Pause 1500
  Pin(DC) = 0
  LcdData= &B00001101 : GoSub LCD_ByteOut     ' Invert
 Pause 1500
  LcdData= &B00001000 : GoSub LCD_ByteOut     ' Blank
 Pause 500
  LcdData= &B00001100 : GoSub LCD_ByteOut     ' Normal

GoTo loopA

LCD_Init:

  Pin(RST) = 0 : Pause 15 : Pin(RST) = 1 : Pin(DC) = 0  ' RESET LCD

  LcdData= &H21 : GoSub LCD_ByteOut        ' LCD EXTENDED COMMANDS
Pause 20
  LcdData= &HC8 : GoSub LCD_ByteOut        ' SET LCD Vop (CONTRAST)
Pause 20
  LcdData= &H06 : GoSub LCD_ByteOut        ' SET TEMP COEFFICENT
Pause 20
  LcdData= &H13 : GoSub LCD_ByteOut        ' LCD BIAS MODE
Pause 20
  LcdData= &H20 : GoSub LCD_ByteOut        ' LCD STANDARD COMMANDS
Pause 20
  LcdData= &H0C : GoSub LCD_ByteOut        ' LCD IN NORMAL MODE
Pause 20
Return

LCD_ByteOut:
 Junk =  SPI(LcdData)        ' datapin clock pin mode Var
Return

LCD_CharOut:

Pin(DC) = 1
bitmap = ((LcdData - 32) * 6)

If Font = 1 Then
If LcdData=46 Then LcdData=LcdData+12
BitMap=((LcdData - 48)*24) + 552 ' Numbers only
EndIf

If font = 0 Then BitMapSize=6
If font = 1 Then BitMapSize=12

 For I = Bitmap To (BitMap+BitMapsize-1)
   Junk = SPI(Codes(I))
 Next I
Counter=I

If BitMapSize=12 Then

PosY=PosY+1:GoSub LCD_GotoXY
For I = Counter To ((Counter+BitMapSize)-1)
   Junk = SPI(Codes(I))
 Next I
Counter = I

PosY=PosY-1:PosX=PosX+12:GoSub LCD_GotoXY
EndIf

Return

LCD_StringOut:
  For CharCount=1 To Len(Text$)
      LcdData=LCDstr(CharCount)
      GoSub LCD_CharOut
  Next CharCount
Return

LCD_Clear:
  PosX=0:PosY=0:GoSub LCD_GotoXY
  Pin(DC)=1
  For Chr=1 To 252
      LcdData=0 : GoSub LCD_ByteOut
      LcdData=0 : GoSub LCD_ByteOut
  Next Chr
Return

LCD_GotoXY:
Pin(DC) = 0
  LcdData=&B01000000 Or PosY : GoSub LCD_ByteOut
  LcdData=&B10000000 Or PosX : GoSub LCD_ByteOut
  Pin(DC) = 1
Return


Sub Lookup
 For Chr= 1 To Len(Text$)
 Bitmap =  Asc(Mid$(Text$, Chr, 1))
      LCDstr(Chr)= BitMap
 Next Chr
End Sub

ReadTemp:
GetTemp 14, Temp, &H7F
Temp$ = Str$(Temp) 'Str$(DS18B20(14))
If Int(Val(Temp$)) < 10 Then Temp$ = " " + Temp$
Temp$ = Left$(Temp$,2) + "." + Str$(Int((Temp-Int(Temp))*10))
SetTick 60000, ReadTemp, 1  'Read Temperature once 60 seconds
IReturn


ReadTime:
' I2C RTC based On DS1307 Secs,Mins,Hours,Day,Date,Month,Year,Control
Dim RTCbuff(8)
i2caddr = &h68 ' DS1307 I2C address
I2C open 100,100 ' Enable I2C
I2C write i2caddr, 0, 1, &h0
I2C Read i2caddr, 0, 8, RTCbuff(0)
I2C Close

sec$ = Str$(decimal)
BCDTEMP = RTCBuff(1)
BCDtoDec BCDTEMP

min$ = Str$(decimal)
BCDTEMP = RTCBuff(2)
BCDtoDec BCDTEMP

hours$ = Str$(decimal)
BCDTEMP = RTCBuff(4)
BCDtoDec BCDTEMP

day$ = Str$(decimal)
BCDTEMP = RTCBuff(5)
BCDtoDec BCDTEMP

month$ = Str$(decimal)
bcdtemp = rtcbuff(6)
BCDtoDec BCDTEMP
year$ = Str$(decimal + 2000 )
t$ = hours$+":"+min$+":"+sec$
D$ = day$+"/"+month$+"/"+year$
Time$ = T$
Date$ = D$
Return


'Convert to Decimal
Sub BCDtoDec (BCDTEMP)
Decimal = Fix(BCDTemp / 16) * 10
Decimal = Decimal + (BCDTEMP And &hF)
End Sub

 ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Subroutine to get the temperature from a Dallas DS18B20.
' Usage GetTemp (Pin number of DS18B20), (Temperature Variable), (Resolution)
' Resolution Table (Resolution Variable)
' &H1F = 9 bits  93.75ms Conversion Time
' &H3F = 10 Bits 187.5ms Conversion Time
' &H5F = 11 Bits 375ms Conversion Time
' &H7F = 12 Bits 750ms Conversion Time
' Temperature of 127 will be displayed
' in the case of a sensor fault
 ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Sub GetTemp (PinNbr, Value, Resolution)
 Local TH, TL, b, t

OneWire Reset PinNbr       ' reset
OneWire Write PinNbr, 2, 5, &HCC, &H4E, &H00, &H00, Resolution
OneWire Write PinNbr, 1, 2, &HCC, &H44

t=Timer
 Do
  If Timer - t > 1000 Then Error "Sensor Error"
   OneWire Read PinNbr, 4, 1, b   ' Conversion status
  Loop Until b = 1

OneWire Write PinNbr, 1, 2, &HCC, &HBE
OneWire Read PinNbr, 2, 2, TL, TH

Value = ((TH And &b111) * 256 + TL) / 16
If T2 And &b1000 Then Value = -Value  ' adjust if negative

End Sub


Codes:                            'Rem READ From AT24C32

 I2C Open 100,100                 'ENABLE I2C
  I2C Write I2CADDR, 0,2,&HF,&HFE 'Array size location
  I2C Read I2CADDR, 0,1,C         'Read number of blocks from EE
  I2C Read I2CADDR, 0,1,D         'Read remainder of blocks from EE
  CData=(D*256)+C                 'Array size Blocks*256 + remainder

Dim Codes(CData)                  ' Dimension array

L=0                               'To Ensure we start at 0
BC=&HFF                           'Complete Block

  For J=0 To D                    'Number of complete blocks
If J=D Then BC=(CData-(D*256))    'Check for end of array
  For I=0 To BC

  I2C Write I2CADDR, 0,2,J,I
  I2C Read I2CADDR, 0,1,Codes(L)

  L=L+1                           'Increment counter

Next I : Next J
 I2C Close
Return