'Write Nokia LCd array to 24C32 EEprom
'John Gerrard


CData=839         'Number of items in the array
S=Int(Cdata/256)  'Number of 256 blocks
Dim Codes(CData)  'Dimension array

GoSub Codes       'Read array

Rem WRITE TO AT24C32

I2CADDR=&H50      'Address of 24c32
I2C Open 100,100 'ENABLE I2C
BC=&HFF           'Complete block

  For J=&h0 To S                'Number of blocks to write
If J=S Then BC = CData-(S*256)  'Full block or remainder
 For I=&h0 To BC

  I2C Write I2CADDR, 0,3,J,I,Codes(Cnt) 'Write to EE

Pause 10                        'Small delay for EE
 Cnt = cnt + 1                  'Increment array counter
 Next i: Next j

I2C Write I2CADDR, 0,4,&Hf,&HFE,BC,S  'Write item count to EE
Pause 10                              'Small delay for EE
I2C Close

 Print "EEProm HAS BEEN WRITTEN with "; cnt ;"  Codes";

 End



'-------------------------------------------------
' Font DATA table
'-------------------------------------------------
Data &H00,&H00,&H00,&H00,&H00,&H00    '  32       20
Data &H00,&H00,&H2f,&H00,&H00,&H00    '  33   !   21
Data &H00,&H07,&H00,&H07,&H00,&H00    '  34   "   22
Data &H14,&H7f,&H14,&H7f,&H14,&H00    '  35   #   23
Data &H24,&H2a,&H7f,&H2a,&H12,&H00    '  36   $   24
Data &Hc4,&Hc8,&H10,&H26,&H46,&H00    '  37   %   25
Data &H36,&H49,&H55,&H22,&H50,&H00    '  38   &   26
Data &H00,&H05,&H03,&H00,&H00,&H00    '  39   '   27
Data &H00,&H1c,&H22,&H41,&H00,&H00    '  40   (   28
Data &H00,&H41,&H22,&H1c,&H00,&H00    '  41   )   29
Data &H14,&H08,&H3E,&H08,&H14,&H00    '  42   *   2A
Data &H08,&H08,&H3E,&H08,&H08,&H00    '  43   +   2B
Data &H00,&H00,&H50,&H30,&H00,&H00    '  44   ,   2C
Data &H08,&H08,&H08,&H08,&H08,&H00    '  45   -   2D
Data &H00,&H60,&H60,&H00,&H00,&H00    '  46   .   2E
Data &H20,&H10,&H08,&H04,&H02,&H00    '  47   /   2f
Data &H3E,&H51,&H49,&H45,&H3E,&H00    '  48   0   30
Data &H00,&H42,&H7F,&H40,&H00,&H00    '  49   1   31
Data &H42,&H61,&H51,&H49,&H46,&H00    '  50   2   32
Data &H21,&H41,&H45,&H4B,&H31,&H00    '  51   3   33
Data &H18,&H14,&H12,&H7F,&H10,&H00    '  52   4   34
Data &H27,&H45,&H45,&H45,&H39,&H00    '  53   5   35
Data &H3C,&H4A,&H49,&H49,&H30,&H00    '  54   6   36
Data &H01,&H71,&H09,&H05,&H03,&H00    '  55   7   37
Data &H36,&H49,&H49,&H49,&H36,&H00    '  56   8   38
Data &H06,&H49,&H49,&H49,&H3E,&H00    '  57   9   39
Data &H00,&H36,&H36,&H00,&H00,&H00    '  58   :   3A
Data &H00,&H56,&H36,&H00,&H00,&H00    '  59   ;   3B
Data &H08,&H14,&H22,&H41,&H00,&H00    '  60   <   3C
Data &H14,&H14,&H14,&H14,&H14,&H00    '  61   =   3D
Data &H00,&H41,&H22,&H14,&H08,&H00    '  62   >   3E
Data &H02,&H01,&H51,&H09,&H06,&H00    '  63   ?   3F
Data &H32,&H49,&H59,&H51,&H3E,&H00    '  64   @   40
Data &H7E,&H11,&H11,&H11,&H7E,&H00    '  65   A   41
Data &H7F,&H49,&H49,&H49,&H36,&H00    '  66   B   42
Data &H3E,&H41,&H41,&H41,&H22,&H00    '  67   C   43
Data &H7F,&H41,&H41,&H22,&H1C,&H00    '  68   D   44
Data &H7F,&H49,&H49,&H49,&H41,&H00    '  69   E   45
Data &H7F,&H09,&H09,&H09,&H01,&H00    '  70   F   46
Data &H3E,&H41,&H49,&H49,&H7A,&H00    '  71   G   47
Data &H7F,&H08,&H08,&H08,&H7F,&H00    '  72   H   48
Data &H00,&H41,&H7F,&H41,&H00,&H00    '  73   I   49
Data &H20,&H40,&H41,&H3F,&H01,&H00    '  74   J   4A
Data &H7F,&H08,&H14,&H22,&H41,&H00    '  75   K   4B
Data &H7F,&H40,&H40,&H40,&H40,&H00    '  76   L   4C
Data &H7F,&H02,&H0C,&H02,&H7F,&H00    '  77   M   4D
Data &H7F,&H04,&H08,&H10,&H7F,&H00    '  78   N   4E
Data &H3E,&H41,&H41,&H41,&H3E,&H00    '  79   O   4F
Data &H7F,&H09,&H09,&H09,&H06,&H00    '  80   P   50
Data &H3E,&H41,&H51,&H21,&H5E,&H00    '  81   Q   51
Data &H7F,&H09,&H19,&H29,&H46,&H00    '  82   R   52
Data &H46,&H49,&H49,&H49,&H31,&H00    '  83   S   53
Data &H01,&H01,&H7F,&H01,&H01,&H00    '  84   T   54
Data &H3F,&H40,&H40,&H40,&H3F,&H00    '  85   U   55
Data &H1F,&H20,&H40,&H20,&H1F,&H00    '  86   V   56
Data &H3F,&H40,&H38,&H40,&H3F,&H00    '  87   W   57
Data &H63,&H14,&H08,&H14,&H63,&H00    '  88   X   58
Data &H07,&H08,&H70,&H08,&H07,&H00    '  89   Y   59
Data &H61,&H51,&H49,&H45,&H43,&H00    '  90   Z   5A
Data &H00,&H7F,&H41,&H41,&H00,&H00    '  91   [   5B
Data &H55,&H2A,&H55,&H2A,&H55,&H00    '  92   \   5C
Data &H00,&H41,&H41,&H7F,&H00,&H00    '  93   ]   5D
Data &H04,&H02,&H01,&H02,&H04,&H00    '  94   ^   5E
Data &H40,&H40,&H40,&H40,&H40,&H00    '  95   _   5F
Data &H00,&H01,&H02,&H04,&H00,&H00    '  96   '   60
Data &H20,&H54,&H54,&H54,&H78,&H00    '  97   a   61
Data &H7F,&H48,&H44,&H44,&H38,&H00    '  98   b   62
Data &H38,&H44,&H44,&H44,&H20,&H00    '  99   c   63
Data &H38,&H44,&H44,&H48,&H7F,&H00    '  100  d   64
Data &H38,&H54,&H54,&H54,&H18,&H00    '  101  e   65
Data &H08,&H7E,&H09,&H01,&H02,&H00    '  102  f   66
Data &H0C,&H52,&H52,&H52,&H3E,&H00    '  103  g   67
Data &H7F,&H08,&H04,&H04,&H78,&H00    '  104  h   68
Data &H00,&H44,&H7D,&H40,&H00,&H00    '  105  i   69
Data &H20,&H40,&H44,&H3D,&H00,&H00    '  106  j   70
Data &H7F,&H10,&H28,&H44,&H00,&H00    '  107  k   71
Data &H00,&H41,&H7F,&H40,&H00,&H00    '  108  l   72
Data &H7C,&H04,&H18,&H04,&H78,&H00    '  109  m   73
Data &H7C,&H08,&H04,&H04,&H78,&H00    '  110  n   74
Data &H38,&H44,&H44,&H44,&H38,&H00    '  111  o   75
Data &H7C,&H14,&H14,&H14,&H08,&H00    '  112  p   76
Data &H08,&H14,&H14,&H18,&H7C,&H00    '  113  q   77
Data &H7C,&H08,&H04,&H04,&H08,&H00    '  114  r   78
Data &H48,&H54,&H54,&H54,&H20,&H00    '  115  s   79
Data &H04,&H3F,&H44,&H40,&H20,&H00    '  116  t   80
Data &H3C,&H40,&H40,&H20,&H7C,&H00    '  117  u   81
Data &H1C,&H20,&H40,&H20,&H1C,&H00    '  118  v   82
Data &H3C,&H40,&H30,&H40,&H3C,&H00    '  119  w   83
Data &H44,&H28,&H10,&H28,&H44,&H00    '  120  x   84
Data &H0C,&H50,&H50,&H50,&H3C,&H00    '  121  y   85
Data &H44,&H64,&H54,&H4C,&H44,&H00    '  122  z   86
Data &H08,&H14,&HE8,&HA0,&HA0,&H00    '  Degree Symbol

' Big Numbers
Data &h00,&hFE,&hFF,&h03,&h03,&hC3  '0
Data &hE3,&h73,&hFF,&hFE,&h00,&h00
Data &h00,&h7F,&hFF,&hCE,&hC7,&hC1
Data &hC0,&hC0,&hFF,&h7F,&h00,&h00

Data &h00,&h00,&h08,&h0C,&h06,&hFF  '1
Data &hFF,&h00,&h00,&h00,&h00,&h00
Data &h00,&h00,&hC0,&hC0,&hC0,&hFF
Data &hFF,&hC0,&hC0,&hC0,&h00,&h00

Data &h00,&h04,&h06,&h03,&h03,&h03  '2
Data &h03,&h83,&hFF,&hFE,&h00,&h00
Data &h00,&hC0,&hE0,&hF0,&hF8,&hCE
Data &hC7,&hC3,&hC1,&hC0,&h00,&h00

Data &h00,&h00,&h03,&h03,&h03,&h03  '3
Data &h63,&hf3,&h9b,&h0f,&h07,&h00
Data &h00,&h00,&h40,&hC0,&hC0,&hC0
Data &hC0,&hc0,&hc1,&h7f,&h3e,&h00

Data &h00,&h80,&hC0,&h60,&h30,&h18  '4
Data &h0C,&h06,&hFF,&hFF,&h00,&h00
Data &h00,&h0F,&h0F,&h0C,&h0C,&h0C
Data &h0C,&h0C,&hFF,&hFF,&h0C,&h00

Data &h00,&hFF,&hFF,&hC3,&hC3,&hC3  '5
Data &hC3,&hC3,&hC3,&hC3,&h00,&h00
Data &h20,&h60,&hC0,&hC0,&hC0,&hC0
Data &hC0,&hC0,&h7F,&h3F,&h00,&h00

Data &h00,&hC0,&hE0,&hF0,&h38,&h1C  '6
Data &h0E,&h07,&h03,&h03,&h03,&h00
Data &h00,&h3F,&h7F,&hC3,&hC3,&hC3
Data &hC3,&hC3,&hC3,&h7E,&h3C,&h00


Data &h00,&h00,&h03,&h03,&h83,&hC3  '7
Data &h63,&h33,&h1B,&h0F,&h07,&h00
Data &h00,&h00,&h00,&h00,&hFF,&hFF
Data &h00,&h00,&h00,&h00,&h00,&h00

Data &h00,&h7C,&hFE,&h83,&h83,&h83  '8
Data &h83,&h83,&h83,&hFE,&h7C,&h00
Data &h00,&h3E,&h7F,&hC1,&hC1,&hC1
Data &hC1,&hC1,&hC1,&h7F,&h3E,&h00

Data &h00,&h00,&h7E,&hFF,&h83,&h83  '9
Data &h83,&h83,&h83,&hFF,&hFE,&h00
Data &h00,&h00,&h40,&hC1,&hC1,&hC1
Data &hC1,&hC1,&hC1,&h7F,&h3F,&h00

Data &h00,&h00,&h00,&h00,&h00,&h00  '.
Data &h00,&h00,&h00,&h00,&h00,&h00
Data &h00,&h00,&hFF,&hFF,&hFF,&hFF
Data &hFF,&hFF,&hFF,&hFF,&h00,&h00

Data &h7C,&h7C,&h6C,&h7C,&h7C,&h00  'Degree Symbol
Data &h00,&h00,&h00,&h00,&h00,&h00
Data &h00,&h00,&h00,&h00,&h3C,&h7E
Data &hC3,&hC3,&hC3,&hC3,&hC3,&h00

Codes:

For I = 0 To CData
 Read Codes(I)
Next I


Return